#include <stdio.h>
#include <io.h>
#include <ctype.h>
#include <string.h>

struct
{ int flag00;
  char name [12];
  int flag01;
  int flag02;
  int flag03;
  int flag04;
  int flag_str;
  int flag_time;
  int flag_cost;
  int flag_move;
  int flag_new;
  int flag_city_str;
  int flag_open_str;
  int flag_wood_str;
  int flag_hill_str;
  int flag_city_stk;
  int flag_open_stk;
  int flag_wood_stk;
  int flag_hill_stk;
  int flag_ally;
  int flag_enemy;
  int flag_siege;
  int flag_mv_fly;
  int flag_mv_woods;
  int flag_mv_hills;
  int flag_navy;
} the_army;

main(argc,argv)
int argc;
char *argv[];

{ FILE *armyfile;
  char armyname[100];

  if (argc!=2)
  { printf("USAGE: showarmy armyname\n");
    exit(1);
  }

  armyfile = fopen(argv[1], "rb");
  if (armyfile == NULL)
  { strcpy(armyname,"a");
    strcat(armyname,argv[1]);
    strcat(armyname,".dat");
    armyfile = fopen(armyname, "rb");
    if (armyfile == NULL)
    { strcpy(armyname,"army\\a");
      strcat(armyname,argv[1]);
      strcat(armyname,".dat");
      armyfile = fopen(armyname, "rb");
      if (armyfile == NULL)
      { printf("Can't find army %s\n",armyname);
        exit(2);
      }
    }
  }
  printf("ARMY: %s\n",argv[1]);
  printf("Ŀ\n");
  printf("   Unit     smvtbc new  Move  Bonuses   Special    Ally \n");
  do
  { fread(&the_army, 1, sizeof(the_army), armyfile);
    if (!feof(armyfile))
    {
      printf("Ĵ\n");
      printf("%-12.12s%1d%2d%1d%2d%5d",the_army.name,
                                            the_army.flag_str,
                                            the_army.flag_move,
                                            the_army.flag_time,
                                            the_army.flag_cost,
                                            the_army.flag_new);

      /* MOVEMENT */

      if ((the_army.flag_mv_woods) && (the_army.flag_mv_hills)) printf(" W/H ");
      else
      { if (the_army.flag_mv_woods) printf("Woods");
        else if (the_army.flag_mv_hills) printf("Hills");
        else if (the_army.flag_mv_fly) printf(" Fly ");
        else printf("     ");
      }
      if ((the_army.flag_city_str) || (the_army.flag_hill_str) ||
          (the_army.flag_open_str) || (the_army.flag_wood_str))
      { /* STRENGTH BONUSES */
        if ((the_army.flag_city_str) && (the_army.flag_hill_str) &&
            (the_army.flag_open_str) && (the_army.flag_wood_str)) printf("All  Str +%1d",the_army.flag_wood_str);
        else
        { if (the_army.flag_city_str) printf("City Str +%1d",the_army.flag_city_str);
          if (the_army.flag_hill_str) printf("Hill Str +%1d",the_army.flag_hill_str);
          if (the_army.flag_open_str) printf("Open Str +%1d",the_army.flag_open_str);
          if (the_army.flag_wood_str) printf("Wood Str +%1d",the_army.flag_wood_str);
        }
      }
      else
      if ((the_army.flag_city_stk) || (the_army.flag_hill_stk) ||
          (the_army.flag_open_stk) || (the_army.flag_wood_stk))
      { /* STACK BONUSES */
        if ((the_army.flag_city_stk) && (the_army.flag_hill_stk) &&
            (the_army.flag_open_stk) && (the_army.flag_wood_stk)) printf("All  Stk +%1d",the_army.flag_wood_stk);
        else
        { if (the_army.flag_city_stk) printf("City Stk +%1d",the_army.flag_city_stk);
          if (the_army.flag_hill_stk) printf("Hill Stk +%1d",the_army.flag_hill_stk);
          if (the_army.flag_open_stk) printf("Open Stk +%1d",the_army.flag_open_stk);
          if (the_army.flag_wood_stk) printf("Wood Stk +%1d",the_army.flag_wood_stk);
        }
      } /* OTHER BONUSES */
      else if (the_army.flag_enemy)    printf("Enemy %1d   ",the_army.flag_enemy);
      else printf("None       ");
      if (the_army.flag_siege==1) printf("Cancel CB  ");
      else if (the_army.flag_siege==2) printf("Cancel HB  ");
      else if (the_army.flag_siege==3) printf("Cancel NHB ");
      else if (the_army.flag_siege==4) printf("Fortified  ");
      else printf("           ");

      if (the_army.flag_ally==0) printf("      ");
      else if (the_army.flag_ally==1) printf("Ally  ");
      else if (the_army.flag_ally==2) printf("Temple");
      printf("\n");
    }
  }
  while (!feof(armyfile));
  printf("\n");
  fclose(armyfile);
}
