#include <stdio.h>
#include <io.h>
#include <ctype.h>
#include <string.h>

struct
{ char listname [20];
  char subdir1 [8];
  char listdesc [30];
  int dummy1;
  char subdir2 [8];
  char subdir3 [8];
  int cities;
  int ruins;
  int players;
  int dummy3;
} the_scenario;

struct
{ char name [20];
  char desc1 [30];
  char desc2 [30];
  char desc3 [30];
  char desc4 [30];
  char desc5 [30];
  char desc6 [30];
} the_design;


FILE *scenfile,*datafile;


void get_data(datatype)
char datatype [8];

{ char text [10],pathname[80];

  strcpy(pathname,the_scenario.subdir1);
  strcat(pathname,"\\");
  strcat(pathname,datatype);
  strcat(pathname,".dat");
  datafile = fopen(pathname, "rb");
  if (datafile == NULL)
  { printf("%s : default\n",datatype);
  }
  else
  { fread(text, 1, 8, datafile);
    if (text[0] == '\0') printf("%s : default\n",datatype);
    else printf("%s : %s\n",datatype,text);
  }
  fclose(datafile);
}

void get_notes()

{ char pathname[80];

  strcpy(pathname,the_scenario.subdir1);
  strcat(pathname,"\\");
  strcat(pathname,"sceninfo.dat");
  datafile = fopen(pathname, "rb");
  if (datafile == NULL)
  { printf("Designer : No design notes\n");
  }
  else
  { fread(&the_design, 1, sizeof(the_design), datafile);
    printf("Designer : %s\n",the_design.name);
    printf("Notes    : %s %s\n",the_design.desc1,the_design.desc2);
    printf("           %s %s\n",the_design.desc3,the_design.desc4);
    printf("           %s %s\n",the_design.desc5,the_design.desc6);
  }
  fclose(datafile);
}

main(argc,argv)
int argc;
char *argv[];

{

  scenfile = fopen("data\\scenario.dat", "rb");
  if (scenfile == NULL)
  { printf("Can't find data\\scenario.dat\n");
    exit(2);
  }
  do
  { fread(&the_scenario, 1, sizeof(the_scenario), scenfile);
    if (!feof(scenfile))
    { printf("Scenario : %s\n",the_scenario.listname);
      printf("Descript : %s\n",the_scenario.listdesc);
      printf("Cities   : %d\n",the_scenario.cities);
      printf("Ruins    : %d\n",the_scenario.ruins);
      printf("Players  : %d\n",the_scenario.players);
      get_notes();
      get_data("armyname");
      get_data("cityname");
      get_data("shldname");
      printf("\n");
    }
  }
  while (!feof(scenfile));
  fclose(scenfile);
}


